> ## Documentation Index
> Fetch the complete documentation index at: https://docs.xerobi.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Attach Payment Method to Customer



## OpenAPI

````yaml POST /customers/{id}/payment_methods
openapi: 3.1.0
info:
  title: Xerobi Payment API
  version: '2026-01-01'
  description: >-
    A developer-first REST API for a modern payment gateway. Focused on
    predictable semantics, idempotency, clear errors, and observability. Use
    `Authorization: Bearer <sk_...>` for requests. All amounts are smallest
    currency unit (e.g. paisa for BDT).
  termsOfService: https://api.hixbe.com/terms
  contact:
    name: Xerobi Developer Support
    url: https://developer.hixbe.com
    email: support@xerobi.com
  license:
    name: Proprietary
    url: https://hixbe.com/license
servers:
  - url: https://sandbox.api.hixbe.com/payment
    description: Sandbox (test)
  - url: https://api.hixbe.com/payment
    description: Production
security:
  - bearerAuth: []
tags:
  - name: PaymentIntents
    description: Orchestrate payments (recommended pattern)
  - name: PaymentMethods
    description: Create and manage payment methods / tokens
  - name: Customers
    description: Customer objects and stored methods
  - name: Refunds
    description: Issue partial/full refunds
  - name: Webhooks
    description: Register webhook endpoints and view events
  - name: Observability
    description: Request debugging and headers
externalDocs:
  description: Developer guides & examples
  url: https://developer.hixbe.com/docs
paths:
  /customers/{id}/payment_methods:
    post:
      tags:
        - Customers
      summary: Attach Payment Method to Customer
      operationId: attachPaymentMethodToCustomer
      parameters:
        - $ref: '#/components/parameters/Xerobi-Version'
        - name: id
          in: path
          required: true
          schema:
            type: string
      requestBody:
        required: true
        content:
          application/json:
            schema:
              type: object
              properties:
                payment_method:
                  type: string
                set_default:
                  type: boolean
              required:
                - payment_method
            example:
              payment_method: pm_card_123
              set_default: true
      responses:
        '200':
          description: Customer updated
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Customer'
        '400':
          $ref: '#/components/responses/GenericError'
components:
  parameters:
    Xerobi-Version:
      name: Xerobi-Version
      in: header
      description: API version header. Use '2026-01-01' for the latest version.
      required: true
      schema:
        type: string
        default: '2026-01-01'
  schemas:
    Customer:
      type: object
      properties:
        id:
          type: string
          example: cus_123
        email:
          type: string
          format: email
        name:
          type: string
        phone:
          type: string
        metadata:
          type: object
          additionalProperties:
            type: string
        default_payment_method:
          type: string
          nullable: true
        created_at:
          type: string
          format: date-time
      required:
        - id
    Error:
      type: object
      properties:
        error:
          type: object
          properties:
            type:
              type: string
              description: >-
                category (invalid_request, auth_error, processing_error,
                rate_limit, internal_error)
            code:
              type: string
              description: machine-friendly error code
            message:
              type: string
              description: human-friendly message
            param:
              type: string
              nullable: true
              description: request parameter related to the error, if any
            request_id:
              type: string
              description: gateway generated request id for debugging
          required:
            - type
            - code
            - message
  responses:
    GenericError:
      description: Standard error response
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/Error'
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer
      bearerFormat: JWT
      description: 'Use your secret API key. Example: `Authorization: Bearer sk_test_xxx`'

````

## Related topics

- [Payment API FAQ](https://docs.xerobi.com/faq-guides/payment-api-faq.md)
- [Attach Payment Method to Payment Intent](https://docs.xerobi.com/payment-api/endpoint/attach-payment-method-to-intent.md)
- [Retrieve Payment Method](https://docs.xerobi.com/payment-api/endpoint/retrieve-payment-method.md)
- [Create Payment Method](https://docs.xerobi.com/payment-api/endpoint/create-payment-method.md)
- [Xerobi Payment API Introduction](https://docs.xerobi.com/payment-api/introduction.md)


This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.